﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Lobs.ApplicationModel
{
  public class Product
  {
    public Product()
    {
      _dmo = new DataModel.Product();
      Category = new Category();
    }

    public string Name { get { return _dmo.Name; } set { _dmo.Name = value; } }

    public Category Category { get; set; }

    public decimal UnitPrice { get { return _dmo.UnitPrice; } set { _dmo.UnitPrice = value; } }

    // etc...


    /// <summary>
    /// Creates Employee or Manager from data model object.
    /// </summary>
    internal static Product FromDataModel(DataModel.Product dmProduct)
    {
      Product product = new Product();
      product._dmo = dmProduct;
      product.Category = ApplicationProcess.Current.KeyTables.Cagegories.FirstOrDefault(category => category.ID == dmProduct.CategoryID);

      return product;
    }

    /// <summary>
    /// Copies properties to data model.
    /// </summary>
    internal DataModel.Product ToDataModel()
    {
      return _dmo;
    }

    internal DataModel.Product _dmo { get; set; }
  }
}
