﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Lobs.DataModel
{
  /// <summary>
  /// DataModel class for employee.
  /// </summary>
  public class Employee : BaseClass
  {
    public string LastName { get; set; }

    public string FirstName { get; set; }

    public string TitleOfCourtesy { get; set; }

    public string Title { get; set; }

    public DateTime BirthDate { get; set; }

    public byte[] Photo { get; set; }

    // etc...

    /// <summary>
    /// Gets a value indicating whether this instance is a manager.
    /// </summary>
    public bool IsManager
    {
      get { return String.IsNullOrEmpty(Title) ? false : Title.Contains("Manager") || Title.Contains("President"); }
    }

  }
}
