﻿Imports System.Diagnostics
Imports System.Threading
Imports Lobs.DataModel

Public Class ApplicationProcess
  ' Methods
  Private Sub New(ByVal dataModel As IDataProvider)
    Me._keyTables = New KeyTables
    Me.DataProvider = dataModel
  End Sub

  Public Shared Sub AcquireAppModel()
    Monitor.Enter(ApplicationProcess._appProcess)
  End Sub

  Public Shared Sub DeInitialize()
    If (Not ApplicationProcess._appProcess Is Nothing) Then
      ApplicationProcess._appProcess = Nothing
    End If
  End Sub

  <Conditional("SILVERLIGHT")> _
  Friend Shared Sub EnsureBackgroundThread()

  End Sub

  Public Sub EnsureData()

  End Sub

  <Conditional("SILVERLIGHT")> _
  Friend Shared Sub EnsureForegroundThread()

  End Sub

  Public Function HasData() As Boolean
    Return False
  End Function

  Public Shared Sub Initialize(ByVal providerName As String)
    If (Not ApplicationProcess._appProcess Is Nothing) Then
      Throw New InvalidOperationException("Only one ApplicationProcess must exist.")
    End If
    ApplicationProcess._appProcess = New ApplicationProcess(DataProviderFactory.GetProvider(providerName))
  End Sub

  Public Sub InitializeKeyTables()
    Me.LoadKeyTables_V1()
  End Sub

  Public Function LoadEmployees() As List(Of Employee)
    Dim data As IEnumerable(Of DataModel.Employee) = Me.DataProvider.LoadEmployees
    Dim list As New List(Of Employee)
    Dim dmEmployee As DataModel.Employee
    For Each dmEmployee In data
      list.Add(Employee.FromDataModel(dmEmployee))
    Next
    Return list
  End Function

  Private Sub LoadKeyTables_V1()
    If Not Me._KeyTablesInitialized Then
      Me._KeyTablesInitialized = True
      Me._KeyTables.SetCategories(Me.DataProvider.LoadCategories)
      Me._KeyTables.SetShippers(Me.DataProvider.LoadShippers)
      Me._KeyTablesInitialized = True
    End If
  End Sub

  Public Function LoadProducts() As List(Of Product)
    Dim data As IEnumerable(Of DataModel.Product) = Me.DataProvider.LoadProducts
    Dim list As New List(Of Product)
    Dim dmProduct As DataModel.Product
    For Each dmProduct In data
      list.Add(Product.FromDataModel(dmProduct))
    Next
    Return list
  End Function

  Public Shared Sub ReleaseAppModel()
    Monitor.Exit(ApplicationProcess._appProcess)
  End Sub

  Public Sub SaveData()

  End Sub

  ' Properties
  Public Shared ReadOnly Property Current() As ApplicationProcess
    Get
      Return _appProcess
    End Get
  End Property
  Private Shared _appProcess As ApplicationProcess

  Public Property DataProvider() As IDataProvider
    Get
      Return _DataProvider
    End Get
    Set(ByVal value As IDataProvider)
      _DataProvider = value
    End Set
  End Property
  Private _DataProvider As IDataProvider

  Public ReadOnly Property Employees() As List(Of Employee)
    Get
      If (Me._Employees Is Nothing) Then
        Me._Employees = New List(Of Employee)
        Dim data As IEnumerable(Of DataModel.Employee) = Me.DataProvider.LoadEmployees
        Dim dmEmployee As DataModel.Employee
        For Each dmEmployee In data
          Me._Employees.Add(Employee.FromDataModel(dmEmployee))
        Next
      End If
      Return Me._Employees
    End Get
  End Property
  Private _Employees As List(Of Employee)

  Public ReadOnly Property KeyTables() As KeyTables
    Get
      Return _KeyTables
    End Get
  End Property
  Private _KeyTables As KeyTables

  Public ReadOnly Property KeyTablesInitialized() As Boolean
    Get
      Return _KeyTablesInitialized
    End Get
  End Property
  Private _KeyTablesInitialized As Boolean
End Class
