﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Linq;
using System.Text;

namespace Lobs.DataModel.AccessDataProvider
{
  /// <summary>
  /// Helper class for Silverlight
  /// </summary>
  static class BitmapConverter
  {
    /// <summary>
    /// Converts a 16 color Windows 1.0 bitmap into something Silverlight can handle.
    /// </summary>
    public static byte[] Convert(byte[] bytes)
    {
      if (bytes != null)
      {
        TypeConverter typeConverter = TypeDescriptor.GetConverter(typeof(Bitmap));
        Bitmap bmp = (Bitmap)typeConverter.ConvertFrom(bytes);
        if (bmp != null)
        {
          var stream = new MemoryStream();
          bmp.Save(stream, ImageFormat.Jpeg);
          bmp.Dispose();
          return stream.ToArray();
        }
      }
      return null;
    }
  }
}
