﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Lobs.DataModel.WcfServiceDataProvider.ServiceReference2;

namespace Lobs.DataModel.WcfServiceDataProvider
{
  public class WcfProvider : IDataProvider
  {
    public static WcfProvider CreateDataProvider()
    {
      return new WcfProvider();
    }

    //public void Initialize()
    //{
    //  var client = new Service2Client();
    //  client.Initialize();
    //}

    //public void Deinitialize()
    //{
    //  var client = new Service2Client();
    //  client.Deinitialize();
    //}

    public IEnumerable<Category> LoadCategories()
    {
      var client = new Service2Client();
      return client.LoadCategories();
    }

    public IEnumerable<Shipper> LoadShippers()
    {
      var client = new Service2Client();
      return client.LoadShippers();
    }

    public IEnumerable<Employee> LoadEmployees()
    {
      var client = new Service2Client();
      return client.LoadEmployees();
    }

    public byte[] LoadEmployeePhoto(string id)
    {
      var client = new Service2Client();
      return client.LoadEmployeePhoto(id);
    }

    public void SaveEmployee(Employee employee)
    {
      throw new NotImplementedException();
    }

    public void DeleteEmployee(Employee employee)
    {
      throw new NotImplementedException();
    }

    public int SaveEmployees(IEnumerable<Employee> employees)
    {
      var list = new List<Employee>();
      list.AddRange(employees);
      var client = new Service2Client();
      return client.SaveEmployees(list);
    }

    public IEnumerable<Product> LoadProducts()
    {
      var client = new Service2Client();
      return client.LoadProducts();
    }

    public void SaveProduct(Product product)
    {
      throw new NotImplementedException();
    }
  }
}
