﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows;
using Frmwrk.Collections.ObjectModel;
using Frmwrk.ComponentModel;
using Frmwrk.Windows.ViewModel;
using Lobs.ApplicationModel;
using Lobs.Views;

namespace Lobs.ViewModel
{
  public class MainViewModel : ViewModelBase
  {
    /// <summary>
    /// Initializes a new instance of the <see cref="MainViewModel"/> class.
    /// </summary>
    public MainViewModel()
    {
#if !SILVERLIGHT
      MainView = new MainView();
      MainView.DataContext = this;
      MainView.Show();
#else
      MainView = new MainView();
      MainView.DataContext = this;
      Application.Current.RootVisual = MainView;
#endif
    }

    MainView MainView { get; set; }


    internal void ShowEmployees()
    {
      var evm = new EmployeesViewModel();
      var view = evm.CreateView();

      MainView.placeholder.Children.Clear();
      MainView.placeholder.Children.Add(view);
    }

    internal void ShowProductDialog()
    {
      var pvm = new ProductDialogModel();
#if !SILVERLIGHT
      var view = pvm.CreateView(MainView);
      view.ShowDialog();
#else
      var view = pvm.CreateView();
      view.Show();
#endif
    }



    ///// <summary>
    ///// The spend overview reeport.
    ///// </summary>
    //public SpendOverviewReport SpendOverviewReport
    //{
    //  get
    //  {
    //    if (_spendOverviewReport == null)
    //      _spendOverviewReport = new SpendOverviewReport();
    //    return _spendOverviewReport;
    //  }
    //}
    //private SpendOverviewReport _spendOverviewReport;

    ///// <summary>
    ///// Gets or sets the current content page.
    ///// </summary>
    ///// <value>The current content page.</value>
    //public ProPageBase CurrentContentPage { get; set; }

    internal void LoadEmployees(ObservableCollection<Employee> collection)
    {
      //var list = ApplicationProcess.Current.LoadEmployees();

      var process = ApplicationProcess.Current;
      var service = new AsyncServiceFunction<List<ApplicationModel.Employee>>(process.LoadEmployees);
      service.ServiceCompleted += LoadEmployeesCompleted;
      service.InvokeServiceAsync(collection);
    }

    void LoadEmployeesCompleted(object sender, AsyncServiceCompletedEventArgs<List<ApplicationModel.Employee>> e)
    {
      var collection = (ObservableCollection<Employee>)e.UserState;
      foreach (var item in e.Result)
      {
        collection.Add(Employee.FromApplicationModel(item));
      }
    }

  }
}
