﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Frmwrk.ComponentModel;
using Lobs.ApplicationModel;
using Lobs.Views;

namespace Lobs.ViewModel
{
  public class ProductDialogModel : ViewModelBase
  {
#if !SILVERLIGHT
    internal ProductDialog CreateView(Window owner)
    {
      View = new ProductDialog();
      View.Owner = owner;
      View.DataContext = this;
      LoadProducts();
      return View;
    }
#else
    internal ProductDialog CreateView()
    {
      View = new ProductDialog();
      View.DataContext = this;
      LoadProducts();
      return View;
    }
#endif

    ProductDialog View { get; set; }

    internal void LoadProducts()
    {
      var service = new AsyncServiceFunction<List<ApplicationModel.Product>>(ApplicationProcess.LoadProducts);
      service.ServiceCompleted += (sender1, e1) =>
        {
          foreach (var item in e1.Result)
            _products.Add(Product.FromApplicationModel(item));
        };
      service.InvokeServiceAsync();
    }

    public ObservableCollection<Product> Products
    {
      get { return _products; }
    }

    readonly ObservableCollection<Product> _products = new ObservableCollection<Product>();
  }
}
