﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Windows;
using Lobs.ApplicationModel;
using Lobs.ViewModel;

namespace Lobs
{
  /// <summary>
  /// Interaction logic for App.xaml
  /// </summary>
  public partial class App : Application
  {
    protected override void OnStartup(StartupEventArgs e)
    {
      base.OnStartup(e);

      // Register several data providers
      DataModel.DataProviderFactory.RegisterProvider("access", () => DataModel.AccessDataProvider.MSAccessProvider.CreateDataProvider("abc"));
      DataModel.DataProviderFactory.RegisterProvider("wcf", DataModel.WcfServiceDataProvider.WcfProvider.CreateDataProvider);

      // Initialize root application process
      ApplicationProcess.Initialize("access");

      // Initialize root view model process
      ViewModelProcess.Initialize();
    }
  }
}

