﻿Imports System.Collections.ObjectModel
Imports Frmwrk.ComponentModel
Imports System.Windows
Imports Lobs
Imports Lobs.ViewModel

Namespace Lobs.ViewModel
  Public Class MainViewModel
    Inherits ViewModelBase

    Public Sub New()
#If silverlight = 0 Then
      Me.MainView = New Lobs.Views.MainView()
      Me.MainView.DataContext = Me
      Me.MainView.Show()
#Else
      Me.MainView = New Lobs.Views.MainView()
      Me.MainView.DataContext = Me
      Application.Current.RootVisual = Me.MainView
#End If
    End Sub

    Friend Sub LoadEmployees(ByVal collection As ObservableCollection(Of Employee))
      Dim service As New AsyncServiceFunction(Of List(Of ApplicationModel.Employee))(New Func(Of List(Of ApplicationModel.Employee))(AddressOf ApplicationProcess.LoadEmployees))
      AddHandler service.ServiceCompleted, New EventHandler(Of AsyncServiceCompletedEventArgs(Of List(Of ApplicationModel.Employee)))(AddressOf Me.LoadEmployeesCompleted)
      service.InvokeServiceAsync(collection)
    End Sub

    Private Sub LoadEmployeesCompleted(ByVal sender As Object, ByVal e As AsyncServiceCompletedEventArgs(Of List(Of ApplicationModel.Employee)))
      Dim collection As ObservableCollection(Of Employee) = DirectCast(e.UserState, ObservableCollection(Of Employee))
      Dim item As ApplicationModel.Employee
      For Each item In e.Result
        collection.Add(Employee.FromApplicationModel(item))
      Next
    End Sub

    Friend Sub ShowEmployees()
      Dim view As UIElement = New EmployeesViewModel().CreateView
      Me.MainView.placeholder.Children.Clear()
      Me.MainView.placeholder.Children.Add(view)
    End Sub

    Friend Sub ShowProductDialog()
      Dim pvm As New ProductDialogModel
#If SILVERLIGHT = 0 Then
      pvm.CreateView(Me.MainView).ShowDialog()
#Else
      pvm.CreateView.Show()
#End If
    End Sub

    Private Property MainView() As Lobs.Views.MainView
      Get
        Return _mainView
      End Get
      Set(ByVal value As Lobs.Views.MainView)
        _mainView = value
      End Set
    End Property
    Private _mainView As Lobs.Views.MainView

  End Class
End Namespace