﻿Imports Lobs
Imports System.Linq.Expressions
Imports System.Reflection

Namespace Lobs.ViewModel
  Public Class Product
    Inherits ViewModelBase

    Public Sub New()
      Me._appProduct = New ApplicationModel.Product
    End Sub

    Public Shared Function FromApplicationModel(ByVal amProduct As ApplicationModel.Product) As Product
      Dim product As New Product
      product._appProduct = amProduct
      Return product
    End Function

    Public Function ToApplicationModel() As ApplicationModel.Product
      If (Me._appProduct Is Nothing) Then
        Me._appProduct = New ApplicationModel.Product
      End If
      Return Me._appProduct
    End Function

    Public Overrides Function ToString() As String
      Return Me.Name
    End Function

    Public Property Category() As ApplicationModel.Category
      Get
        Return Me._appProduct.Category
      End Get
      Set(ByVal value As ApplicationModel.Category)
        If Not Object.ReferenceEquals(Me._appProduct.Category, value) Then
          Me._appProduct.Category = value
          MyBase.RaisePropertyChanged(Function() Category)
        End If
      End Set
    End Property

    Public Property Name() As String
      Get
        Return Me._appProduct.Name
      End Get
      Set(ByVal value As String)
        If Not Object.ReferenceEquals(Me._appProduct.Name, value) Then
          Me._appProduct.Name = value
          MyBase.RaisePropertyChanged(Function() Name)
        End If
      End Set
    End Property

    Public Property UnitPrice() As Decimal
      Get
        Return Me._appProduct.UnitPrice
      End Get
      Set(ByVal value As Decimal)
        If (Me._appProduct.UnitPrice <> value) Then
          Me._appProduct.UnitPrice = value
          MyBase.RaisePropertyChanged(Function() UnitPrice)
        End If
      End Set
    End Property

    ' Fields
    Private _appProduct As ApplicationModel.Product
  End Class
End Namespace