﻿Imports Lobs
Imports System.Runtime.CompilerServices
Imports System.ComponentModel
Imports Frmwrk.ComponentModel

Namespace Lobs.ViewModel
  Public Class ViewModelProcess
    Inherits ViewModelBase

    Private Sub New()
      Dim service As New AsyncServiceAction(New Action(AddressOf MyBase.ApplicationProcess.InitializeKeyTables))
      AddHandler service.ServiceCompleted, AddressOf ServiceCompleted
    End Sub

    Sub ServiceCompleted(ByVal sender As Object, ByVal e As AsyncCompletedEventArgs)
      Dim service As AsyncServiceAction = DirectCast(sender, AsyncServiceAction)
      service.InvokeServiceAsync()
    End Sub

    Public Shared Sub Initialize()
      If (Not ViewModelProcess._viewModelProcess Is Nothing) Then
        Throw New InvalidOperationException("Only one ViewModelProcess must exist.")
      End If
      ViewModelProcess._viewModelProcess = New ViewModelProcess
      ViewModelProcess._viewModelProcess.MainWindow = New MainViewModel
    End Sub

    Public Shared ReadOnly Property Current() As ViewModelProcess
      Get
        Return _viewModelProcess
      End Get
    End Property

    Public Property MainWindow() As MainViewModel
      Get
        Return _mainWindow
      End Get
      Set(ByVal value As MainViewModel)
        _mainWindow = value
      End Set
    End Property
    Private _mainWindow As MainViewModel

    Private Shared _viewModelProcess As ViewModelProcess
  End Class
End Namespace