﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Net;
#if SILVERLIGHT
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
#endif

namespace Frmwrk.Collections.ObjectModel
{
  public static class CollectionExtensions
  {
#if SILVERLIGHT
    /// <summary>
    /// Adds the elements of the specified collection to the end of the ObservableCollection.
    /// </summary>
    public static void AddRange<T>(this ObservableCollection<T> collection, IEnumerable<T> list)
    {
      foreach (var item in list)
        collection.Add(item);
    }
#endif

#if SILVERLIGHT
    /// <summary>
    /// Adds the elements of the specified collection to the end of the Collection.
    /// </summary>
    public static void AddRange<T>(this Collection<T> collection, IEnumerable<T> list)
    {
      foreach (var item in list)
        collection.Add(item);
    }
#endif
  }
}
