﻿using System;
using System.Runtime.InteropServices;

namespace Frmwrk.Win32.NativeMethods
{
  /// <summary>
  /// Encapsulates some native Windows functions of Kernel32.dll. 
  /// See Microsoft SDK documentation for further details.
  /// </summary>
  public static class Kernel32
  {
    public const int DONT_RESOLVE_DLL_REFERENCES = 0x00000001;
    public const int LOAD_LIBRARY_AS_DATAFILE = 0x00000002;
    public const int LOAD_WITH_ALTERED_SEARCH_PATH = 0x00000008;
    public const int LOAD_IGNORE_CODE_AUTHZ_LEVEL = 0x00000010;

    [DllImport("Kernel32.dll")]
    public static extern IntPtr LoadLibrary(string fileName);
    [DllImport("Kernel32.dll")]
    public static extern IntPtr LoadLibraryEx(string fileName, IntPtr fileHandle, int flags);

    [DllImport("kernel32.dll", EntryPoint = "GetConsoleWindow")]
    static extern IntPtr GetConsoleWindow();
  }
}
